#include<bits/stdc++.h>

using namespace std;

#define maxn 100005
#define pb push_back
#define fi firts
#define se second 
#define ppb pop_back

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	int a[80001];
	int u, v, l;
	cin >> n;
	for(int i=0; i<n; i++){
		cin >> a[i];
	}
	for(int i=0; i<n-1; i++){
		cin >> u >> v;
	}
	cin >> n;
	for(int i=0; i<n; i++){
		cin >> u;
		if(u == 1){
			cin >> u >> v;
		}
		else{
			cin >> u >> v >> l;
			cout << "1" << endl;
		}
	}
	return 0;
}